﻿using System;
using Microsoft.Data.Schema.SchemaModel;
using Microsoft.Data.Schema;
using System.Collections.Generic;

namespace MySql.Dsp.SchemaModel
{
    internal sealed class MySqlDataSchemaModel : DataSchemaModel
    {
        private MySqlDatabaseSchemaProvider dsp;

        public MySqlDataSchemaModel(MySqlDatabaseSchemaProvider dsp, 
            ModelCollation collation, ModelSchema storeSchema, String modelFileName, 
            ScriptCache scriptCache, ErrorManager errorManager)
            : base(collation, storeSchema, modelFileName, scriptCache, errorManager)
        {
            this.dsp = dsp;
        }

        public override void BeginBatchUpdate()
        {
        }

        public override DatabaseSchemaProvider DatabaseSchemaProvider
        {
            get { return dsp; }
        }

        public override int ElementProcessingOperationsCount
        {
            get { throw new NotImplementedException(); }
        }

        public override void EndBatchUpdate()
        {
        }

        protected override ICollection<ISourceInformation> GetElementSources(IModelElement element)
        {
            throw new NotImplementedException();
        }

        protected override ICollection<ISourceInformation> GetRelationshipEntrySources(IModelRelationshipEntry relationshipEntry)
        {
            throw new NotImplementedException();
        }

        public override void Resolve(int elementCount)
        {
            throw new NotImplementedException();
        }

        public override void Resolve()
        {
            throw new NotImplementedException();
        }

        #region Constructor

        internal class Constructor : DataSchemaModelConstructor
        {
            protected override DataSchemaModel ConstructServiceImplementation()
            {
                MySqlDatabaseSchemaProvider dsp = this.DatabaseSchemaProvider as MySqlDatabaseSchemaProvider;
                return new MySqlDataSchemaModel(dsp, Collation, dsp.ModelSchema, ModelFileName, ScriptCache, ErrorManager);
            }
        }

        #endregion
    }
}
